import "Turbine.UI";


BackGroundSelectorWindow = class(Turbine.UI.Control)
function BackGroundSelectorWindow:Constructor(label,bg)
  Turbine.UI.Control.Constructor(self);
  self:SetBackColor(Turbine.UI.Color(rgb(0),rgb(15),rgb(40)));
  self.bgSelector = BackGroundSelector(label,bg);
  self.bgSelector:SetPosition(1,1);
  self.bgSelector:SetParent(self);
  self.bgSelector.ValueChanged = function(s,a) _G.eventWalletChange(s,a); end;
end

function BackGroundSelectorWindow:Layout()
  local width = self:GetWidth();
  self.bgSelector:SetWidth(width-2);
  self:SetHeight(self.bgSelector:GetHeight()+2);
  self.bgSelector:SetEnabled(true);
end

BackGroundSelector = class(Turbine.UI.Control)
function BackGroundSelector:Constructor(label,bg)
  Turbine.UI.Control.Constructor(self);
  self:SetBackColor(Turbine.UI.Color(rgb(0),rgb(0),rgb(0)));
  self.bg = bg;
  
  self.titleControl = Turbine.UI.Control();
  self.titleControl:SetParent(self);
  self.titleControl:SetPosition(2,2);

  self.titleControl.label = VLabel(label,0,0,string.len(label) * 8,16);
  self.titleControl.label:SetParent(self.titleControl);
  self.titleControl.label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
  
  self.titleControl.colorpane = Turbine.UI.Control();
  self.titleControl.colorpane:SetParent(self.titleControl);
  self.titleControl.colorpane:SetSize(2*16,16);
  self.titleControl.colorpane:SetPosition(4+self.titleControl.label:GetLeft()+self.titleControl.label:GetWidth(),0);

  self.titleControl.colorpane:SetBackColor(Turbine.UI.Color(rgb(self.bg.a),rgb(self.bg.r),rgb(self.bg.g),rgb(self.bg.b)));
  self.titleControl:SetSize(self.titleControl.label:GetWidth()+self.titleControl.colorpane:GetWidth(),16);
  
  local height = self.titleControl:GetHeight();
  
  self.redSlider = Slider();
  self.redSlider:SetParent(self);
  self.redSlider:SetText(L["red"]);
  self.redSlider:SetPosition(0,height);
  self.redSlider:SetSize(350, 40);
  self.redSlider:SetStep(1);
  self.redSlider:SetMin(0);
  self.redSlider:SetMax(255);
  self.redSlider:SetValue(self.bg.r);
  self.redSlider.ValueChanged = function(s,a)
    self.bg.r = a.value;
    self.titleControl.colorpane:SetBackColor(Turbine.UI.Color(rgb(self.bg.a),rgb(self.bg.r),rgb(self.bg.g),rgb(self.bg.b)));
    ExecuteCallback(self,"ValueChanged",{self.bg.r});
  end
 
  height = height + self.redSlider:GetHeight();
  
  self.greenSlider = Slider();
  self.greenSlider:SetParent(self);
  self.greenSlider:SetText(L["green"]);
  self.greenSlider:SetPosition(0,height);
  self.greenSlider:SetSize(350, 40);
  self.greenSlider:SetStep(1);
  self.greenSlider:SetMin(0);
  self.greenSlider:SetMax(255);
  self.greenSlider:SetValue(self.bg.g);
  self.greenSlider.ValueChanged = function(s,a)
    self.bg.g = a.value;
    self.titleControl.colorpane:SetBackColor(Turbine.UI.Color(rgb(self.bg.a),rgb(self.bg.r),rgb(self.bg.g),rgb(self.bg.b)));
    ExecuteCallback(self,"ValueChanged",{self.bg.g});
  end
  
  height = height + self.greenSlider:GetHeight();
  
  self.blueSlider = Slider();
  self.blueSlider:SetParent(self);
  self.blueSlider:SetText(L["blue"]);
  self.blueSlider:SetPosition(0,height);
  self.blueSlider:SetSize(350, 40);
  self.blueSlider:SetStep(1);
  self.blueSlider:SetMin(0);
  self.blueSlider:SetMax(255);
  self.blueSlider:SetValue(self.bg.b);
  self.blueSlider.ValueChanged = function(s,a)
    self.bg.b = a.value;
    self.titleControl.colorpane:SetBackColor(Turbine.UI.Color(rgb(self.bg.a),rgb(self.bg.r),rgb(self.bg.g),rgb(self.bg.b)));
    ExecuteCallback(self,"ValueChanged",{self.bg.b});
  end
  
  height = height + self.blueSlider:GetHeight();
  
  self.alphaSlider = Slider();
  self.alphaSlider:SetParent(self);
  self.alphaSlider:SetText(L["alpha"]);
  self.alphaSlider:SetPosition(0,height);
  self.alphaSlider:SetSize(350, 40);
  self.alphaSlider:SetStep(1);
  self.alphaSlider:SetMin(0);
  self.alphaSlider:SetMax(255);
  self.alphaSlider:SetValue(self.bg.a);
  self.alphaSlider.ValueChanged = function(s,a)
    self.bg.a = a.value;
    self.titleControl.colorpane:SetBackColor(Turbine.UI.Color(rgb(self.bg.a),rgb(self.bg.r),rgb(self.bg.g),rgb(self.bg.b)));
    ExecuteCallback(self,"ValueChanged",{self.bg.a});
  end
  
  height = height + self.alphaSlider:GetHeight()
  
  self:SetHeight(height);
end

function BackGroundSelector:SetEnabled(v)
  self.redSlider:SetEnabled(v);
  self.greenSlider:SetEnabled(v);
  self.blueSlider:SetEnabled(v);
  self.alphaSlider:SetEnabled(v);
end
