import "Gillothrin.Items.VindarPatch";

DataOptions = class(Turbine.Object);
function DataOptions:Constructor()
  Turbine.Object.Constructor(self);
  self.namespace = pluginName.."Options";
  self:LoadData();

  if(self.notSelectedItems == nil) then
    self.notSelectedItems = {};
  end
  if(self.seenWalletItems == nil) then
    self.seenWalletItems = {};
  end
end

function DataOptions:LoadData()
  local euroFormat=(tonumber("1,000")==1);
  if euroFormat then
    function euroNormalize(value) return tonumber((string.gsub(value,"%.",","))) end
  else
    function euroNormalize(value) return tonumber((string.gsub(value,",","."))) end
  end
  local obj = Turbine.Object();
  pcall(function() obj = PatchDataLoad( Turbine.DataScope.Character, self.namespace)	end	);
  if obj ~= nil then
    self.mainLeft = obj.mainLeft;
    self.mainTop = obj.mainTop;
    self.mainWidth = obj.mainWidth;
    self.mainHeight = obj.mainHeight;
    self.nrback = obj.nrback;
    self.iconback = obj.iconback;
    self.vertback = obj.vertback;
    self.notSelectedItems = obj.notSelectedItems;
    self.seenWalletItems = obj.seenWalletItems;
    self.oneline = obj.oneline;
    self.nopack = obj.nopack;
  end
end

function DataOptions:SaveData()
  echo(_G.pluginName.." Saved Data");
  local obj = Turbine.Object();
  obj.mainLeft = self.mainLeft;
  obj.mainTop = self.mainTop;
  obj.mainHeight = self.mainHeight;
  obj.mainWidth = self.mainWidth;
  obj.notSelectedItems = self.notSelectedItems;
  obj.seenWalletItems = self.seenWalletItems;
  obj.nrback = self.nrback;
  obj.iconback = self.iconback;
  obj.vertback = self.vertback;
  obj.oneline = self.oneline;
  obj.nopack = self.nopack;
  pcall(function() PatchDataSave( Turbine.DataScope.Character, self.namespace, obj) end);
end
