import "Turbine.UI.Lotro";

CImage = class(Turbine.UI.Control);
function CImage:Constructor(url, left, top, width, height,name,parent)		
	Turbine.UI.Control.Constructor( self );
	if (width ~= nil) and (height ~= nil) and (left ~= nil) and (top ~= nil) and (url ~= nil) then	
		self:SetPosition(left, top);
		self:SetBlendMode(Turbine.UI.BlendMode.Normal);
		self:SetParent(parent);		
		self:SetBackground(url);
		self:SetSize(width, height);
		self.name = name;	
	end	
end

VLabel = class(Turbine.UI.Label);
function VLabel:Constructor(text, left, top, width, height)
	Turbine.UI.Label.Constructor( self );
	if (width ~= nil) and (height ~= nil) and (left ~= nil) and (top ~= nil) and (text ~= nil) then
		self:SetSize(width, height);		
		self:SetPosition(left, top);
		self:SetText(text);
	end
end

VButton = class(Turbine.UI.Lotro.Button);
function VButton:Constructor(text, left, top, width, height)
	Turbine.UI.Lotro.Button.Constructor( self );
	if (width ~= nil) and (height ~= nil) and (left ~= nil) and (top ~= nil) and (text ~= nil) then
		self:SetSize(width, height);		
		self:SetPosition(left, top);
		self:SetText(text);
	end
end

VCheckBox = class(Turbine.UI.Lotro.CheckBox);
function VCheckBox:Constructor(toggled,left,top,width,height)
	Turbine.UI.Lotro.CheckBox.Constructor( self );
	if (width ~= nil) and (height ~= nil) and (left ~= nil) and (top ~= nil) and (toggled ~= nil) then
		self:SetSize(width,height);
		self:SetPosition(left,top);
		self:SetChecked(toggled);
	end
end

function ValidatePosition(x, y, width, height)
    x = math.min(math.max(x, 0), math.max(Turbine.UI.Display:GetWidth() - width,0));
    y = math.min(math.max(y, 0), math.max(Turbine.UI.Display:GetHeight() - height,0));
    return x, y;
end
