import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
--------------------------------------
import "Gillothrin.Items.Class";
import "Gillothrin.Items.Type";
import "Gillothrin.Items.VindarPatch";
--------------------------------------
import "Gillothrin.Items.Plugin";

_G.debugMode = false;

-- have some defaults TODO remove these
_G.shellCommandName = "wit";
_G.pluginName = "WalletItemTracker";
_G.debugPluginName = pluginName;

Plugins[pluginName].Load = function(self,sender,args)
  _G.pluginFullIdText = self:GetName() .. " v" .. self:GetVersion() .. " (c) 2017 by " .. self:GetAuthor();
  Turbine.Shell.WriteLine("Plugin " .. pluginFullIdText);

  if debugMode then Turbine.Shell.WriteLine("Debug mode ON") end

  local language = Turbine.Engine.GetLanguage();
  _G.locale = (language == Turbine.Language.German and "de" or (language == Turbine.Language.French and "fr" or (language == Turbine.Language.Russian and "ru" or "en" )));
  _G.L = {}

  if (locale == "en" or locale == "de") then
    import ("Gillothrin.Locale."..locale);
  else
    import ("Gillothrin.Locale.en");
    pcall(import, ("Gillothrin.Locale."..locale));
  end

  _G.itemsPlugin = ItemsPlugin();

  if Turbine.Shell.IsCommand(shellCommandName) then
    echo("An command of ".. shellCommandName .. " is already installed, cannot install plugin");
  else
    myCommandLine = itemsPlugin:RegisterShellCommand();
    Turbine.Shell.AddCommand( shellCommandName, myCommandLine );
    Plugins[pluginName].GetOptionsPanel = function(self) return itemsPlugin:GetOptionsPanel() end;
    echo(myCommandLine:GetShortHelp());
  end
end;

Plugins[pluginName].Unload = function(self,sender,args)
  itemsPlugin:Unload();
  _G.itemsPlugin = nil;
  _G.debugMode = nil;
  _G.shellCommandName = nil;
  _G.pluginName = nil;
  _G.debugPluginName = nil;
  echo(pluginFullIdText .. " was removed!");
end;

