import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Gillothrin.Items.GUI";
import "Gillothrin.Items.WalletOptionItem";
import "Gillothrin.Items.Utils";
import "Gillothrin.Items.SelectionPane";
import "Gillothrin.Items.BackGroundSelectorWindow";

OptionsControl = class(Turbine.UI.Control);
function OptionsControl:Constructor(optionsObj,wallet)
  Turbine.UI.Control.Constructor(self);
  self.selectionPane = SelectionPane(optionsObj,wallet);
  self.selectionPane:SetParent(self);
  self.optionsObj = optionsObj;
  
  if optionsObj.iconback == nil then
    optionsObj.iconback = Turbine.Object();
    optionsObj.iconback.a = 255;
    optionsObj.iconback.r = 7;
    optionsObj.iconback.g = 32;
    optionsObj.iconback.b = 71;
  end
  
  self.backgroundSelector = BackGroundSelectorWindow(L["iconbackground"],optionsObj.iconback);
  self.backgroundSelector:SetParent(self);
    
  if optionsObj.nrback == nil then
    optionsObj.nrback = Turbine.Object();
    optionsObj.nrback.a = 255
    optionsObj.nrback.r = 2
    optionsObj.nrback.g = 44;
    optionsObj.nrback.b = 112;
  end
  self.nrbackgroundSelector = BackGroundSelectorWindow(L["numberbackground"],optionsObj.nrback);
  self.nrbackgroundSelector:SetParent(self);
  
  if optionsObj.vertback == nil then
    optionsObj.vertback = Turbine.Object();
    optionsObj.vertback.a = 102;
    optionsObj.vertback.r = 0
    optionsObj.vertback.g = 0;
    optionsObj.vertback.b = 0;
  end
  
  self.vertbarSelector = BackGroundSelectorWindow(L["vertbarbackground"],optionsObj.vertback);
  self.vertbarSelector:SetParent(self);
  
  self.checkers = Turbine.UI.Control();
  self.checkers:SetParent(self);
   
  self.forceOneLine = Turbine.UI.Control();
  self.forceOneLine:SetParent(self.checkers);
  self.forceOneLine:SetPosition(0,0);
  self.forceOneLine:SetHeight(20);
  if self.optionsObj.oneline == nil then self.optionsObj.oneline = false; end;
  self.forceOneLine.checkBox = VCheckBox(self.optionsObj.oneline,0,0,100,20);  
  self.forceOneLine.checkBox:SetParent(self.forceOneLine);
  self.forceOneLine.checkBox:SetText(L["forceoneline"]);
  
  self.forceNoPack = Turbine.UI.Control();
  self.forceNoPack:SetParent(self.checkers);
  self.forceNoPack:SetPosition(0,20);
  self.forceNoPack:SetHeight(20);
  if self.optionsObj.nopack == nil then self.optionsObj.nopack = false; end;
  self.forceNoPack.checkBox = VCheckBox(self.optionsObj.nopack,0,0,100,20);
  self.forceNoPack.checkBox:SetParent(self.forceNoPack);
  self.forceNoPack.checkBox:SetText(L["forcenopack"]);
  
  local this = self;
  AddCallback(self.forceOneLine.checkBox,"CheckedChanged",function(s,a)
    this.optionsObj.oneline = s:IsChecked();
    _G.eventWalletChange(s,a);
  end);

  AddCallback(self.forceNoPack.checkBox, "CheckedChanged",function(s,a)
    this.optionsObj.nopack = s:IsChecked();
    _G.eventWalletChange(s,a);
  end);

  self.checkers:SetHeight(self.forceOneLine:GetWidth()+self.forceNoPack:GetHeight());
  
end

function OptionsControl:RepaintOptionsControl()
  self.selectionPane:Layout();
  local width, height = self.selectionPane:GetSize();
  
  self.backgroundSelector:SetPosition(0,height);
  self.backgroundSelector:SetWidth(width);
  self.backgroundSelector:Layout();
  
  height = height + self.backgroundSelector:GetHeight();
  
  self.nrbackgroundSelector:SetPosition(0,height);
  self.nrbackgroundSelector:SetWidth(width);
  self.nrbackgroundSelector:Layout();
  
  height = height + self.nrbackgroundSelector:GetHeight();
  
  self.vertbarSelector:SetPosition(0,height);
  self.vertbarSelector:SetWidth(width);
  self.vertbarSelector:Layout();
  
  height = height + self.vertbarSelector:GetHeight();
  
  self.checkers:SetPosition(0,height);
  self.checkers:SetWidth(width);
  self.forceNoPack:SetWidth(width);
  self.forceNoPack.checkBox:SetWidth(width);
  self.forceOneLine:SetWidth(width);
  self.forceOneLine.checkBox:SetWidth(width);
  
  height = height + self.checkers:GetHeight();
  
  self:SetSize(width,height);
end

function OptionsControl:ShowOptionsControl()
  self:RepaintOptionsControl();
  self:SetVisible(true);
  Turbine.PluginManager.ShowOptions(Plugins[pluginName]);
end

function OptionsControl:Unload()
  self.selectionPane:Unload();
end

