import "Turbine.UI";
import "Gillothrin.Items.GUI";
import "Gillothrin.Items.VindarPatch";
import "Gillothrin.Items.Utils";
import "Gillothrin.Items.Slider";

SelectionPane = class (Turbine.UI.Control)
function SelectionPane:Constructor(optionsObj,wallet)
  Turbine.UI.Control.Constructor(self)
  self.optionsWidth = 400;
  self.optionsHeight = 400;
  self.optionsObj = optionsObj;
  self.wallet = wallet;
  self:SetHeight(self.optionsHeight);
  self:SetWidth(self.optionsWidth);

  self.checkAllBoxControl = Turbine.UI.Control();
  self.checkAllBoxControl:SetParent(self);
  self.checkAllBoxControl:SetPosition(0,0);
  self.checkAllBoxControl:SetHeight(20);
  self.checkBox = VCheckBox(false,0,0,self.optionsWidth,20);
  self.checkBox:SetParent(self.checkAllBoxControl);
  self.checkBox:SetText(L["CheckBoxAll"]);

  self.listBox = Turbine.UI.ListBox();
  self.listBox:SetParent(self);
  self.listBox:SetBackColor( Turbine.UI.Color(rgb(0),rgb(0),rgb(0)) );
  self.listBox:SetPosition( 0, 20 );
  self.listBox:SetSize( self.optionsWidth, self.optionsHeight-100);

  local this = self;
  self.CheckAllBoxes = function(s,a)
    for i=1,this.listBox:GetItemCount() do
      local item = this.listBox:GetItem(i);
      item.checkBox:SetChecked(s:IsChecked());
    end
  end

  AddCallback(self.checkBox,"CheckedChanged",self.CheckAllBoxes);
  
  self.buttonController = Turbine.UI.Control();
  self.buttonController:SetParent(self);
  self.buttonController:SetBackColor( Turbine.UI.Color(rgb(0),rgb(0),rgb(0)) );
  
  self.optionsCancelButton = VButton("Cancel",195,10,100,20);
  self.optionsCancelButton:SetParent(self.buttonController);  

  self.OptionsCancel = function(s,a)
    this:Layout();
  end
  
  AddCallback(self.optionsCancelButton,"Click",self.OptionsCancel);

  self.optionsSaveButton = VButton("Save",45,10,100,20);
  self.optionsSaveButton:SetParent(self.buttonController);

  self.OptionSave = function(s,a)
    local uncheckedElements = {};
    for i=1,this.listBox:GetItemCount() do
      local item = this.listBox:GetItem(i);
      if (not item.checkBox:IsChecked()) then
        uncheckedElements[item.name] = true;
      end
    end
    this.optionsObj.notSelectedItems = uncheckedElements;
    this.optionsObj:SaveData();
    _G.eventWalletChange(this,this.optionsObj);-- yak!
  end
  AddCallback(self.optionsSaveButton,"Click",self.OptionSave);
end

function SelectionPane:Layout()
  local rowHeight = 20;
  local foundItems = self.optionsObj.seenWalletItems;

  local height = 0;
  local maxCheckBoxWidth = self.listBox:GetWidth();
  self.listBox:ClearItems();

  for k,v in pairs(foundItems) do
    if(self.optionsObj.notSelectedItems[k]) then
      self.listBox:AddItem(WalletOptionItem(k,v,maxCheckBoxWidth,false,rowHeight));
    else
      self.listBox:AddItem(WalletOptionItem(k,v,maxCheckBoxWidth,true,rowHeight));
    end
    height = height + rowHeight;
  end
  
  self.listBox:SetHeight(height);
  self.listBox:Sort(function(a,b) return a.name < b.name end);
  
  self.buttonController:SetPosition(0,height);
  self.buttonController:SetSize(self:GetWidth(),40);
  
  height = height + self.buttonController:GetHeight();
  
  self:SetSize(self.optionsWidth,height);
end

function SelectionPane:Unload()
  RemoveCallback(self.optionsSaveButton,"Click",self.OptionSave);
  RemoveCallback(self.optionsCancelButton,"Click",self.OptionsCancel);
  RemoveCallback(self.checkBox,"CheckedChanged",self.CheckAllBoxes);
end